---
title: "2019 Survey, Soil Quality Relationships"
author: "Real Food Campaign"
date: "`r format( Sys.Date(), '%m/%d/%Y' )`"
output:
  html_document:
    default: true
    keep_md: true
    toc: true
    toc_float: true
    toc_collapsed: true
    toc_depth: 3
    number_sections: true
---


```{r init,echo=FALSE,warnings=FALSE}

load("../bigFiles/qualityRels.RSession")
setwd( "../soilQualityRelsFiles" )
library("tidyverse")
library("kableExtra")
library(knitr)
library(GGally)

knitr::opts_chunk$set(
                    fig.width=7,
                    fig.height=10,
                    echo=FALSE,
                    warning=FALSE,
                    message=FALSE
                  )

```


# Context and Purpose of this Brief

  This document concentrates our analysis around soil helath indicators. Our main intentios are **measuring impact of soil helath over our crop quality variables**, **assesment of the potential of this variables to add predictive power to our machine learning models** and **summarising and testing the effects of management practices over soil health indicators**.


#### Crop Nutritional Density Variables

```{r variables,echo=FALSE,warning=FALSE}
explained <- tribble(
  ~ Nutritional,
  "Antioxidants",
  "Polyphenols",
  "Brix"
)

explicative <- tribble(
  ~ Soil,
  "Organic Carbon Percentage 10cm deep",
  "Organic Carbon Percentage 20cm deep",
  "Soil PH, 10cm deep",
  "Soil PH, 10cm deep",
  "Soil respiration, 10cm deep",
  "Soil respiration, 10cm deep"
)

explained %>% kable( caption = "Crop Nutritional Density Variables" ) %>% kable_styling(
                                                                            c( "hover", "striped" ),
                                                                            full_width = FALSE,
                                                                            fixed_thead = TRUE
                                                          )

```

### Soil Health Variables

```{r}
explicative %>% kable( caption = "Soil Health Variables" ) %>% kable_styling(
                                                                 c( "hover", "striped" ),
                                                                 full_width = FALSE,
                                                                 fixed_thead = TRUE
                                                                            )

```

## Methodologies

  We've realized extensive medians comparisons in the past for crop nutritional quality indicators ( *antioxidants*, *polyphenols* and *brix* ). Methods, code implementations and a detailed guide on how we are interpreting results are all detailed on a previous brief available on the same site where this one is offered, *2019 Survey, Quality Relationships Analysis*.

  The predictive potential and impact of soil health indicators over nutritional density indicators will be measured by a non parametrical measure of correlation, *Spearman's Rank Correlation Coefficient*, in line with the rank tests employed for median shifts on our *Quality Relationships* synthesis tables.


```{r echo=TRUE, warning=FALSE, echo=FALSE}

generalMediansTable <- tibble()

studiedVariables <- c(
  "PH_soil_10cm",
  "PH_soil_20cm",
  "respiration_soil_10cm",
  "respiration_soil_20cm",
  "organic_carbon_percentage_10cm",
  "organic_carbon_percentage_20cm"
)

soilTables <- function( variable, factors = factorsList, data = dataframe, imgBaseDir="./graphics/soil/", reportToGenTable = TRUE ) {
  output <- list()

  filtArray <- tribble(
    ~ variable, ~ value,
    ## "crop", selCrop
  )

  cropDF <- data %>%
    ## filter( crop == selCrop ) %>%
    select( !!studiedVariables,
           !!factors,
           sourceUID
           )

  output$df <- cropDF

  freqsTable90 <- frequencyDelta( explainedVar = variable,
                                 data = cropDF,
                                filteringArray = filtArray,
                                explicativeFactors = factors)

  output$table90 <- freqsTable90

  freqsTable75 <- frequencyDelta( explainedVar = variable,
                                data = cropDF,
                                filteringArray = filtArray,
                                explicativeFactors = factors,
                                rangeMin = 0.75)

  output$table75 <- freqsTable75

  freqsTable15 <- frequencyDelta( explainedVar = variable,
                                 data = cropDF,
                                 filteringArray = filtArray,
                                 explicativeFactors = factors,
                                 rangeMin = 0,
                                 rangeMax = 0.15
                                 )

  output$table15 <- freqsTable15

  output$mediansPractices <- pmap_df( enframe( farmPracticesCols, name = NULL ), ~ positionStatisticsByLogicColumn(
                                                                                  data = cropDF,
                                                                                  column = .x,
                                                                                  explained = variable,
                                                                                  center = "farm_practices.none"
                                                                                )
                                     ) %>% filter( N != 0 )

  output$mediansAmendments <- pmap_df( enframe( amendmentsCols, name = NULL ), ~ positionStatisticsByLogicColumn(
                                                                                data = cropDF,
                                                                                column = .x,
                                                                                explained = variable,
                                                                                center = "amendments.none"
                                                                              )
                                      ) %>% filter( N != 0 )

  if ( reportToGenTable ) {

    medPract <- output$mediansPractices %>% mutate( explained = variable,
                                                   ## crop =selCrop,
                                                   family = "practices"
                                                  )
    medAmend <- output$mediansAmendments %>% mutate( explained = variable,
                                                   ## crop =selCrop,
                                                   family = "amendments"
                                                   )
    generalTable <- bind_rows( generalMediansTable, medPract, medAmend )
    assign( "generalMediansTable", generalTable, envir = .GlobalEnv )
  }

  return( output )
}

dataframe <- dataframe %>% mutate( respiration_soil_10cm = as.double( respiration_soil_10cm ) )
dataframe <- dataframe %>% mutate( respiration_soil_20cm = as.double( respiration_soil_20cm ) )
dataframe <- dataframe %>% mutate( organic_carbon_percentage_10cm = as.double( organic_carbon_percentage_10cm ) )
dataframe <- dataframe %>% mutate( organic_carbon_percentage_20cm = as.double( organic_carbon_percentage_20cm ) )


PH10cm <- soilTables( variable = "PH_soil_10cm" , factors = factorsList, data = dataframe, imgBaseDir="./graphics/soil/", reportToGenTable = TRUE )

PH20cm <- soilTables( variable = "PH_soil_20cm" , factors = factorsList, data = dataframe, imgBaseDir="./graphics/soil/", reportToGenTable = TRUE )

respiration10cm <- soilTables( variable = "respiration_soil_10cm" , factors = factorsList, data = dataframe, imgBaseDir="./graphics/soil/", reportToGenTable = TRUE )

respiration20cm <- soilTables( variable = "respiration_soil_20cm" , factors = factorsList, data = dataframe, imgBaseDir="./graphics/soil/", reportToGenTable = TRUE )

organic10 <- soilTables( variable = "organic_carbon_percentage_10cm", factors = factorsList, data = dataframe, imgBaseDir="./graphics/soil/", reportToGenTable = TRUE )

organic20 <- soilTables( variable = "organic_carbon_percentage_20cm", factors = factorsList, data = dataframe, imgBaseDir="./graphics/soil/", reportToGenTable = TRUE )


generalMediansTable <-  generalMediansTable %>% arrange( factor, explained, - N )
write_rds( x= generalMediansTable, path="./soilMediansTable.Rds" )
write_csv( x= generalMediansTable, path="./soilMediansTable.csv" )


synthesisTable <- generalMediansTable %>%
  filter( isRelevant == TRUE & !is.na( isRelevant ) ) %>%
  select( factor, family, explained, N, p.value, intervalMin, intervalMax ) %>%
  pivot_wider( names_from = c( explained ), values_from = c( N, p.value, intervalMin, intervalMax ) ) %>%
  mutate( factor = str_replace( string = factor, pattern = "(amendments.)|(farm_practices.)", replacement = "" ) )

amendmentsSynthesis <- synthesisTable %>% filter( family == "amendments" )
practicesSynthesis <- synthesisTable %>% filter( family == "practices" )

write_rds( x = amendmentsSynthesis, path=".soilAmendmentsSynthesisTable.Rds" )
write_csv( x = amendmentsSynthesis, path=".soilAmendmentsSynthesisTable.csv" )
write_rds( x = practicesSynthesis, path=".soilPracticesSynthesisTable.Rds" )
write_csv( x = practicesSynthesis, path=".soilPracticesSynthesisTable.csv" )

referenceValues <- generalMediansTable %>%
  filter( str_detect( string = factor, pattern="none" ) ) %>%
  select( factor, "HL Estimate", explained, family ) %>%
  mutate( reference = .data[["HL Estimate"]] ) %>%
  select( explained, family, reference )

generalMediansTable <- left_join( x= generalMediansTable, y = referenceValues, by=c( "explained", "family") )

relevantsTable <- generalMediansTable %>%
  filter( observedUIDs >= 3 ) %>%
  mutate( shiftPercentage = .data[['HL Median Shift Estimate']] / reference,
         shiftPercentage = round( shiftPercentage * 100, digits = 2 )
         ## shiftPercentage = round( shiftPercentage * 100, digits = 2 ) %>% str_c( ., "%", sep ="" )
         ) %>%
  select( factor, explained, shiftPercentage, family ) %>%
  pivot_wider( names_from = explained, values_from = c( shiftPercentage ) ) %>%
  mutate( factor = str_replace( string = factor, pattern = "(amendments.)|(farm_practices.)", replacement = "" ) ) %>%
  select( factor, family, contains("10cm"), contains("20cm") )

sampleSizesTable <- generalMediansTable %>%
  filter( observedUIDs >= 3 ) %>%
  select( factor, explained, family, N ) %>%
  pivot_wider( names_from = c( explained ), values_from = c( N ) ) %>%
  mutate( factor = str_replace( string = factor, pattern = "(amendments.)|(farm_practices.)", replacement = "" ) ) %>%
  select( factor, family, contains("10cm"), contains("20cm") )

pValuesTable <- generalMediansTable %>%
  filter( observedUIDs >= 3 ) %>%
  mutate( p.value = ifelse( p.value > 0.1 & isRelevant == TRUE, 0.09, p.value  ) ) %>%
  select( factor, explained, family, p.value ) %>%
  pivot_wider( names_from = c( explained ), values_from = c( p.value ) ) %>%
  mutate( factor = str_replace( string = factor, pattern = "(amendments.)|(farm_practices.)", replacement = "" ) ) %>%
  select( factor, family, contains("10cm"), contains("20cm") )


relevants <- relevantsTable

pValueAlphaScale <- function( pValue ) {
  pValue <- 1 - pValue
  if ( pValue >= 0.95 ) { return(1) }
  else if ( pValue > 0.90 ) { return(0.70) }
  else if ( pValue > 0.8 ) { return(0.60) }
  else if ( pValue > 0.5 ) { return(0.4) }
  else if ( pValue < 0.1 ) { return(0.1) }
  else { return(0.3) }
}

assignBackgroundNonVec <- function( value, pValue ) {
  if ( is.na(value) | is.na(pValue) | typeof( value ) != "double" ) { return("none") }
  pValue <- pValueAlphaScale( pValue )
  if ( value >= 0 ) { return( paste0( "rgba(1,121,11,", pValue ,")" ) ) }
  else if ( value < 0 ) { return( paste0( "rgba(255,0,0,", pValue ,")" ) ) }
}

assignBackground <- function( vecsValue, vecsPValue ) {
  map2_chr( vecsValue, vecsPValue, assignBackgroundNonVec )
}

assignColorNonVec <- function( value ) {
  if ( is.na(value) | typeof( value ) != "double" ) { return("black") }
  else if ( value == 0 ) { return("white") }
  else if ( value > 0 ) { return("white") }
  else if ( value < 0 ) { return("white") }
}

assignColor <- function( vecsValue ) {
  vecsValue %>% map_chr( assignColorNonVec )
}

formatCols <- relevants %>% select( -"factor", -"family" ) %>%
  colnames

relevantSpecAmendments <- relevants %>% filter( family == "amendments" ) %>% select( - "family" )

sampleSizesAmendments <- sampleSizesTable %>% filter(  family == "amendments") %>% select( - "family" )

pValuesAmendments <- pValuesTable %>% filter(  family == "amendments") %>% select( - "family" )

for ( col in formatCols ) {
  relevantSpecAmendments[[col]] <- cell_spec(
    relevantSpecAmendments[[col]],
    background = assignBackground( relevantSpecAmendments[[col]], pValuesAmendments[[col]] ),
    tooltip = sampleSizesAmendments[[col]] %>% str_c( "Sample size: ", ., sep = "" ) ,
    color = assignColor( relevantSpecAmendments[[col]] ),
    bold = TRUE
  )
}

fullColorAmendments <- relevantSpecAmendments %>%
  filter( factor != "none" ) %>%
  mutate( factor = str_replace_all( factor, pattern = "_", replacement = " " ) %>% str_to_title( . ) ) %>%
  rename_all( ~ str_replace_all( ., pattern = "_", replacement = " " ) %>% str_to_title( . ) ) %>%
  kable( escape = FALSE, caption = "Percent of Variation over Median Value" ) %>%
  kable_styling( c( "hover", "striped" ),
                full_width = FALSE,
                fixed_thead = TRUE
                ) %>%
  column_spec( 1, bold = TRUE, border_right = TRUE )

write_rds( fullColorAmendments, path="./soilHealthAmendmentsShiftTable.Rds" )

relevantSpecPractices <- relevants %>% filter( family == "practices" ) %>% select( - "family" )

sampleSizesPractices <- sampleSizesTable %>% filter(  family == "practices") %>% select( - "family" )

pValuesPractices <- pValuesTable %>% filter(  family == "practices") %>% select( - "family" )

for ( col in formatCols ) {
  relevantSpecPractices[[col]] <- cell_spec(
    relevantSpecPractices[[col]],
    background = assignBackground( relevantSpecPractices[[col]], pValuesPractices[[col]] ),
    tooltip = sampleSizesPractices[[col]] %>% str_c( "Sample size: ", ., sep = "" ) ,
    color = assignColor( relevantSpecPractices[[col]] ),
    bold = TRUE
  )
}

fullColorPractices <- relevantSpecPractices %>%
  filter( factor != "none" ) %>%
  mutate( factor = str_replace_all( factor, pattern = "_", replacement = " " ) %>% str_to_title( . ) ) %>%
  rename_all( ~ str_replace_all( ., pattern = "_", replacement = " " ) %>% str_to_title( . ) ) %>%
  kable( escape = FALSE, caption = "Percent of Variation over Median Value" ) %>%
  kable_styling( c( "hover", "striped" ),
                full_width = FALSE,
                fixed_thead = TRUE
                ) %>%
  column_spec( 1, bold = TRUE, border_right = TRUE )

write_rds( fullColorPractices, path="./soilHealthPracticesShiftTable.Rds" )


```


```{r correlations}

generalFitsTable <- tibble()

soilGraphics <- function( selCrop, variable, data = dataframe, imgBaseDir="./graphics/soil/" ) {

  output <- list()

  filtArray <- tribble(
    ~ variable, ~ value,
    "crop", selCrop
  )

  cropDF <- data %>%
    filter( crop == selCrop ) %>%
    select( !!studiedVariables, !!sym(variable) ) %>%
    na.omit

  output$df <- cropDF

  correlations <- cor( cropDF, method = "kendall" )

  heatmap <- ggcorr(
    cropDF,
    method = c( "pairwise", "spearman" ),
    nbreaks = 6,
    hjust = 0.8,
    label = TRUE,
    label_size = 3,
    color = "grey50"
  )

  output$heatmap <- heatmap

  modelFormula <- paste0( variable, "~" ,"." ) %>% as.formula
  model1 <- lm( formula = modelFormula , cropDF, singular.ok = TRUE )
  summary1 <- summary( model1 )
  output$summary1 <- summary1
  output$model1 <- model1

  dataLength <- model1$residuals %>% length()
  chop <-  model1$residuals %>% abs() %>% sort %>% tail( ceiling( dataLength * 0.15 ) ) %>% names %>% as.integer()

  model2 <- lm( formula = modelFormula , ( cropDF %>% slice( - chop ) ), singular.ok = TRUE )
  summary2 <- summary( model2 )
  output$modelN <- dataLength
  output$summary2 <- summary2
  output$model2 <- model2

  fitSummary <- tribble(
    ~ "Crop", ~ "Variable", ~"Samples", ~"R2", ~"trimmed R2",
    selCrop, variable, dataLength, summary1$adj.r.squared, summary2$adj.r.squared
  )

  generalTable <- bind_rows( fitSummary , generalFitsTable )
  assign( "generalFitsTable", generalTable, envir = .GlobalEnv )


  return( output )

}

carrotAntioxidantsCors <-  soilGraphics( "carrot", "antioxidants", data = dataframe, imgBaseDir="./graphics/soil/" )
carrotPolyphenolsCors <-  soilGraphics( "carrot", "polyphenols", data = dataframe, imgBaseDir="./graphics/soil/" )
carrotBrixCors <-  soilGraphics( "carrot", "brix", data = dataframe, imgBaseDir="./graphics/soil/" )

spinachAntioxidantsCors <-  soilGraphics( "spinach", "antioxidants", data = dataframe, imgBaseDir="./graphics/soil/" )
spinachPolyphenolsCors <-  soilGraphics( "spinach", "polyphenols", data = dataframe, imgBaseDir="./graphics/soil/" )
spinachBrixCors <-  soilGraphics( "spinach", "brix", data = dataframe, imgBaseDir="./graphics/soil/" )

lettuceAntioxidantsCors <-  soilGraphics( "lettuce", "antioxidants", data = dataframe, imgBaseDir="./graphics/soil/" )
lettucePolyphenolsCors <-  soilGraphics( "lettuce", "polyphenols", data = dataframe, imgBaseDir="./graphics/soil/" )
lettuceBrixCors <-  soilGraphics( "lettuce", "brix", data = dataframe, imgBaseDir="./graphics/soil/" )

kaleAntioxidantsCors <-  soilGraphics( "kale", "antioxidants", data = dataframe, imgBaseDir="./graphics/soil/" )
kalePolyphenolsCors <-  soilGraphics( "kale", "polyphenols", data = dataframe, imgBaseDir="./graphics/soil/" )
kaleBrixCors <-  soilGraphics( "kale", "brix", data = dataframe, imgBaseDir="./graphics/soil/" )

cherry_tomatoAntioxidantsCors <-  soilGraphics( "cherry_tomato", "antioxidants", data = dataframe, imgBaseDir="./graphics/soil/" )
cherry_tomatoPolyphenolsCors <-  soilGraphics( "cherry_tomato", "polyphenols", data = dataframe, imgBaseDir="./graphics/soil/" )
cherry_tomatoBrixCors <-  soilGraphics( "cherry_tomato", "brix", data = dataframe, imgBaseDir="./graphics/soil/" )

grapeAntioxidantsCors <-  soilGraphics( "grape", "antioxidants", data = dataframe, imgBaseDir="./graphics/soil/" )
grapePolyphenolsCors <-  soilGraphics( "grape", "polyphenols", data = dataframe, imgBaseDir="./graphics/soil/" )
grapeBrixCors <-  soilGraphics( "grape", "brix", data = dataframe, imgBaseDir="./graphics/soil/" )

generalFitsTable <- generalFitsTable %>% arrange( - .data[["trimmed R2"]] )

```


# Cuantification of Soil Quality Variables over Produce Quality Variables

  As stated, we are measuring correlation between soil and nutritional variables for each crop.
  Two linear regressions will be adjusted for each crop, explaining a nutritional variable with all six soil variables.
  
  On a first step, a **first linear model** is adjusted for all the explicative variables and all data points available. Then an **$\alpha$ trimming** is performed for the $15%$ biggest residuals and a **second model** is adjusted with this high residuals trimmmed dataset.
  
  We don't expect such a simple regression to yield a complete prediction of this variables, which have proven remarkably complex to predict in a regressive context. Good $R^2$ results will inform that this variables are good material to increase the predictive power of our current complex models, like Random Forests which already employ spectrometry, regions, varieties, etc.

## Fit Quality on Each Crop and Variable

```{r regressionsFit, echo=FALSE}

generalFitsTable %>% kable( caption = "Crop Nutritional Density Variables" ) %>% kable_styling(
                                                                                   c( "hover", "striped" ),
                                                                                   full_width = FALSE,
                                                                                   fixed_thead = TRUE
                                                                                     )

```

### Remarks on Linear Model Fits

  It is evident that the `grape` regression is overfitted (6 variables, 14 observations), but the regressions over `lettuce` show an excellent fit for both `antioxidants` and `polyphenols` and the regressions for `spinach` show promising values for `antioxidants` and `brix`. These four models have healthy sample sizes.

  We are not cross validating this models because sample sizes are not big enough and because we won't be aplying immediately this method due to the fact that this variables are much less available than the other variables employed, therefore incorporating them would severely hinder the total amount of samples employed for model training. This explorations indicate that obtaining more soil information is worth the effort.

  This table is ordered according to the $\alpha$ trimeed $R^2$ and it can be observed that results until row 12 are encouraging. This means that, besides the two succesfull regressions mentioned, these soil variables contain a considerable amount of useful information and would probably be of value if added to complexer predictive models.
  
### Comparison Between the Succesive Models

  Outliers are a main concernt when working with these hightly volatile variables. $\alpha$ trimming, even while being a rather primitive solution, yielded dramatic increases in accuracy for some regressions, notably `polyphenols` on `spinach`, which cuadruples its $R^2$ and changes from a low performance to a high value.

### Attempt of a Non Overfitted Model for Grapes

  We'll fit `grapes` with two alternative datasets of three variables each, one for  the "10cm" depth, the other for "20cm".
  
  Due to sample scarcity, these results are just indicators about the potential interest of a further exploration of models explaining nutritional content by soil variables.


```{r grapes, echo=FALSE}
grapesDF <- dataframe %>%
  filter( crop == "grape" ) %>%
  select( studiedVariables, antioxidants, polyphenols, brix ) %>%
  na.omit

grapesAnti1 <- lm( antioxidants ~ ., data = ( grapesDF %>% select( contains( "10cm" ), antioxidants ) ) )
grapesAnti2 <- lm( antioxidants ~ ., data = ( grapesDF %>% select( contains( "20cm" ), antioxidants ) ) )

grapesPolyphenols1 <- lm( polyphenols ~ ., data = ( grapesDF %>% select( contains( "10cm" ), polyphenols ) ) )
grapesPolyphenols2 <- lm( polyphenols ~ ., data = ( grapesDF %>% select( contains( "20cm" ), polyphenols ) ) )

grapesBrix1 <- lm( brix ~ ., data = ( grapesDF %>% select( contains( "10cm" ), brix ) ) )
grapesBrix2 <- lm( brix ~ ., data = ( grapesDF %>% select( contains( "20cm" ), brix ) ) )

grapesTable <- tribble(
  ~ Explained, ~Depth, ~"R^2",
  "antioxidants", "10cm", ( grapesAnti1 %>% summary %>% .$adj.r.squared ),
  "antioxidants", "20cm", ( grapesAnti2 %>% summary %>% .$adj.r.squared ),
  "polyphenols", "10cm", ( grapesPolyphenols1 %>% summary %>% .$adj.r.squared ),
  "polyphenols", "20cm", ( grapesPolyphenols2 %>% summary %>% .$adj.r.squared ),
  "brix", "10cm", ( grapesBrix1 %>% summary %>% .$adj.r.squared ),
  "brix", "20cm", ( grapesBrix2 %>% summary %>% .$adj.r.squared )
)

grapesTable %>% kable( caption = "Crop Nutritional Density Variables" ) %>% kable_styling(
                                                                              c( "hover", "striped" ),
                                                                              full_width = FALSE,
                                                                              fixed_thead = TRUE
                                                                                 )

```

### Residuals Graphics for the Most Promissing Regressions

#### Antioxidants on Lettuce

```{r lettuceAnti, echo=F}

lettuceAntioxidants <- tibble(
  Residuals = carrotAntioxidantsCors$model1$residuals,
  Antioxidants = carrotAntioxidantsCors$df$antioxidants,
  Fitted = carrotAntioxidantsCors$model1$fitted.values
)


lettuceAntioxidants %>%
  ggplot() +
  aes( x = Antioxidants, y = Residuals ) +
  geom_point() +
  labs(
    title = "Residuals vs Values"
  )

lettuceAntioxidants %>%
  ggplot() +
  aes( x = Antioxidants, y = Fitted ) +
  geom_point() +
  labs(
    title = "Training Values vs Fitted Values"
  )

lettuceAntioxidants %>%
  ggplot() +
  aes( sample = Residuals ) +
  geom_qq() +
  geom_qq_line() +
  labs(
    title = "QQ Plot for Residuals"
  )
```

#### Antioxidants on Lettuce

```{r lettucePoly, echo=F}

lettucePolyphenols <- tibble(
  Residuals = carrotPolyphenolsCors$model1$residuals,
  Polyphenols = carrotPolyphenolsCors$df$polyphenols,
  Fitted = carrotPolyphenolsCors$model1$fitted.values
)


lettucePolyphenols %>%
  ggplot() +
  aes( x = Polyphenols, y = Residuals ) +
  geom_point() +
  labs(
    title = "Residuals vs Values"
  )

lettucePolyphenols %>%
  ggplot() +
  aes( x = Polyphenols, y = Fitted ) +
  geom_point() +
  labs(
    title = "Training Values vs Fitted Values"
  )

lettucePolyphenols %>%
  ggplot() +
  aes( sample = Residuals ) +
  geom_qq() +
  geom_qq_line() +
  labs(
    title = "QQ Plot for Residuals"
  )
```


#### Antioxidants on Spinach

```{r spinachAnti, echo=F}

spinachAntioxidants <- tibble(
  Residuals = carrotAntioxidantsCors$model1$residuals,
  Antioxidants = carrotAntioxidantsCors$df$antioxidants,
  Fitted = carrotAntioxidantsCors$model1$fitted.values
)


spinachAntioxidants %>%
  ggplot() +
  aes( x = Antioxidants, y = Residuals ) +
  geom_point() +
  labs(
    title = "Residuals vs Values"
  )

spinachAntioxidants %>%
  ggplot() +
  aes( x = Antioxidants, y = Fitted ) +
  geom_point() +
  labs(
    title = "Training Values vs Fitted Values"
  )

spinachAntioxidants %>%
  ggplot() +
  aes( sample = Residuals ) +
  geom_qq() +
  geom_qq_line() +
  labs(
    title = "QQ Plot for Residuals"
  )
```

#### Antioxidants on Spinach

```{r spinachPoly, echo=F}

spinachPolyphenols <- tibble(
  Residuals = carrotPolyphenolsCors$model1$residuals,
  Polyphenols = carrotPolyphenolsCors$df$polyphenols,
  Fitted = carrotPolyphenolsCors$model1$fitted.values
)


spinachPolyphenols %>%
  ggplot() +
  aes( x = Polyphenols, y = Residuals ) +
  geom_point() +
  labs(
    title = "Residuals vs Values"
  )

spinachPolyphenols %>%
  ggplot() +
  aes( x = Polyphenols, y = Fitted ) +
  geom_point() +
  labs(
    title = "Training Values vs Fitted Values"
  )

spinachPolyphenols %>%
  ggplot() +
  aes( sample = Residuals ) +
  geom_qq() +
  geom_qq_line() +
  labs(
    title = "QQ Plot for Residuals"
  )
```

# Quality Relationship Tables

  We offer separatedly the synthesis of this tables on the same site were this brief is available, showing the shifts as percentages of deviation over the median and the sample sizes. 
  
  This variables have shown interesting behaviours. As we are not accounting for the crop factor, populations are robust for most evaluated practices, and most of them have shown shifts that our test could detect as significant. 
  
  Tables offered below are much deeper so the recommended procedure is searching for interesting data on the synthesis tables, and then getting a deeper insight by looking at the complete summaries. 
  
  Besites the medians shift analysis, we've performed a much more informal summary for the frequency of factors on certaing percentiles. The intuitive idea behind this procedure is that if the frequency of *Practice X* over the whole dataset is $30%$ but while looking at the "10%" biggest values for the vaiable it doubles to $60%$, it is probably *concentrated* among the most succesfull crops. There are tables for the best and worst percentiles showing this behaviour. 
  
  It's main advantage is that it spares the reader looking at the enormuos amount of graphics that would have been involved in comparint all these factors for each of the three variables and that it shows patterns even while not detected as relevant by the test, could be interesting for certain investigators or worth an additional exploration.

## Percentual Shift Over the Median Value for Farm Practices

### p.values Code Key

```{r, echo=FALSE }
codeKey <- read_rds( "../produceQualityRelationships/pValuesCodeKey.Rds" )
codeKey
```

### Tables

```{r practices , echo=FALSE}
fullColorPractices
```

## Percentual Shift Over the Median for Soil Amendments

```{r amendments, echo=FALSE}
fullColorAmendments
```

## Quality Replationships for PH at 10cm

### Median Shifts

```{r PH10cm, echo=FALSE}

PH10cm$mediansPractices %>%
  mutate( factor = str_replace( factor, pattern = "farm_practices.", replacement ="" ) ) %>%
  kable( caption = "Farm Practices: Position Measures and Median Comparisons with the 'none' category" )%>% kable_styling(
                                                                                                              c( "hover", "striped" ),
                                                                                                              full_width = FALSE,
                                                                                                              fixed_thead = TRUE
                                                                                                            )

PH10cm$mediansAmendments %>%
  mutate( factor = str_replace( factor, pattern = "amendments.", replacement ="" ) ) %>%
  kable( caption = "Amendments: Position Measures and Median Comparisons with the 'none' category." )%>% kable_styling(
                                                                                                           c( "hover", "striped" ),
                                                                                                           full_width = FALSE,
                                                                                                           fixed_thead = TRUE
                                                                                                         )
```

### Density Variation on Certain Percentiles

On this tables, we attempt to find interesting patterns to explain atypicals and hopefully all variance for a given variable. 

We've already looked at these tables in detail on the *Quality Relationships* brief for produce: we are comparing how frequent is to find a certain quality for the full dataset and for a certain quantile, implying that if a certain attribute is more usual between the points on an extreme, it is worth checking if it is influential over the variable and explains the outlyingness of some values.

```{r PH10cmFreqs, echo=FALSE}
PH10cm$table90 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption = "Presence on the Last Decile for Every Practice" )%>% kable_styling(
                                                                           c( "hover", "striped" ),
                                                                           full_width = FALSE,
                                                                           fixed_thead = TRUE
                                                                         )

PH10cm$table75 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption =  "Presence on the Last Quartile for Every Practice" )%>% kable_styling(
                                                                              c( "hover", "striped" ),
                                                                              full_width = FALSE,
                                                                              fixed_thead = TRUE
                                                                            )

PH10cm$table15 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption =  "Presence on the Worst 15% for Every Practice" )%>% kable_styling(
                                                                          c( "hover", "striped" ),
                                                                          full_width = FALSE,
                                                                          fixed_thead = TRUE
                                                                        )
```


## Quality Replationships for PH at 20cm

### Median Shifts

```{r PH20cm, echo=FALSE}
PH20cm$mediansPractices %>%
  mutate( factor = str_replace( factor, pattern = "farm_practices.", replacement ="" ) ) %>%
  kable( caption = "Farm Practices: Position Measures and Median Comparisons with the 'none' category" )%>% kable_styling(
                                                                                                              c( "hover", "striped" ),
                                                                                                              full_width = FALSE,
                                                                                                              fixed_thead = TRUE
                                                                                                            )

PH20cm$mediansAmendments %>%
  mutate( factor = str_replace( factor, pattern = "amendments.", replacement ="" ) ) %>%
  kable( caption = "Amendments: Position Measures and Median Comparisons with the 'none' category." )%>% kable_styling(
                                                                                                           c( "hover", "striped" ),
                                                                                                           full_width = FALSE,
                                                                                                           fixed_thead = TRUE
                                                                                                         )
```

### Density Variation on Certain Percentiles

On this tables, we attempt to find interesting patterns to explain atypicals and hopefully all variance for a given variable. 

We've already looked at these tables in detail on the *Quality Relationships* brief for produce: we are comparing how frequent is to find a certain quality for the full dataset and for a certain quantile, implying that if a certain attribute is more usual between the points on an extreme, it is worth checking if it is influential over the variable and explains the outlyingness of some values.

```{r PH20cmFreqs, echo=FALSE}
PH20cm$table90 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption = "Presence on the Last Decile for Every Practice" )%>% kable_styling(
                                                                           c( "hover", "striped" ),
                                                                           full_width = FALSE,
                                                                           fixed_thead = TRUE
                                                                         )

PH20cm$table75 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption =  "Presence on the Last Quartile for Every Practice" )%>% kable_styling(
                                                                              c( "hover", "striped" ),
                                                                              full_width = FALSE,
                                                                              fixed_thead = TRUE
                                                                            )

PH20cm$table15 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption =  "Presence on the Worst 15% for Every Practice" )%>% kable_styling(
                                                                          c( "hover", "striped" ),
                                                                          full_width = FALSE,
                                                                          fixed_thead = TRUE
                                                                        )
```


## Quality Replationships for respiration at 10cm

### Median Shifts

```{r respiration10cm, echo=FALSE}
respiration10cm$mediansPractices %>%
  mutate( factor = str_replace( factor, pattern = "farm_practices.", replacement ="" ) ) %>%
  kable( caption = "Farm Practices: Position Measures and Median Comparisons with the 'none' category" )%>% kable_styling(
                                                                                                              c( "hover", "striped" ),
                                                                                                              full_width = FALSE,
                                                                                                              fixed_thead = TRUE
                                                                                                            )

respiration10cm$mediansAmendments %>%
  mutate( factor = str_replace( factor, pattern = "amendments.", replacement ="" ) ) %>%
  kable( caption = "Amendments: Position Measures and Median Comparisons with the 'none' category." )%>% kable_styling(
                                                                                                           c( "hover", "striped" ),
                                                                                                           full_width = FALSE,
                                                                                                           fixed_thead = TRUE
                                                                                                         )
```

### Density Variation on Certain Percentiles

On this tables, we attempt to find interesting patterns to explain atypicals and hopefully all variance for a given variable. 

We've already looked at these tables in detail on the *Quality Relationships* brief for produce: we are comparing how frequent is to find a certain quality for the full dataset and for a certain quantile, implying that if a certain attribute is more usual between the points on an extreme, it is worth checking if it is influential over the variable and explains the outlyingness of some values.

```{r respiration10cmFreqs, echo=FALSE}
respiration10cm$table90 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption = "Presence on the Last Decile for Every Practice" )%>% kable_styling(
                                                                           c( "hover", "striped" ),
                                                                           full_width = FALSE,
                                                                           fixed_thead = TRUE
                                                                         )

respiration10cm$table75 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption =  "Presence on the Last Quartile for Every Practice" )%>% kable_styling(
                                                                              c( "hover", "striped" ),
                                                                              full_width = FALSE,
                                                                              fixed_thead = TRUE
                                                                            )

respiration10cm$table15 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption =  "Presence on the Worst 15% for Every Practice" )%>% kable_styling(
                                                                          c( "hover", "striped" ),
                                                                          full_width = FALSE,
                                                                          fixed_thead = TRUE
                                                                        )
```

## Quality Replationships for Soil Respiration at 20cm

### Median Shifts

```{r respiration20cm, echo=FALSE}
respiration20cm$mediansPractices %>%
  mutate( factor = str_replace( factor, pattern = "farm_practices.", replacement ="" ) ) %>%
  kable( caption = "Farm Practices: Position Measures and Median Comparisons with the 'none' category" )%>% kable_styling(
                                                                                                              c( "hover", "striped" ),
                                                                                                              full_width = FALSE,
                                                                                                              fixed_thead = TRUE
                                                                                                            )

respiration20cm$mediansAmendments %>%
  mutate( factor = str_replace( factor, pattern = "amendments.", replacement ="" ) ) %>%
  kable( caption = "Amendments: Position Measures and Median Comparisons with the 'none' category." )%>% kable_styling(
                                                                                                           c( "hover", "striped" ),
                                                                                                           full_width = FALSE,
                                                                                                           fixed_thead = TRUE
                                                                                                         )
```

### Density Variation on Certain Percentiles

On this tables, we attempt to find interesting patterns to explain atypicals and hopefully all variance for a given variable. 

We've already looked at these tables in detail on the *Quality Relationships* brief for produce: we are comparing how frequent is to find a certain quality for the full dataset and for a certain quantile, implying that if a certain attribute is more usual between the points on an extreme, it is worth checking if it is influential over the variable and explains the outlyingness of some values.

```{r respiration20cmFreqs, echo=FALSE}
respiration20cm$table90 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption = "Presence on the Last Decile for Every Practice" )%>% kable_styling(
                                                                           c( "hover", "striped" ),
                                                                           full_width = FALSE,
                                                                           fixed_thead = TRUE
                                                                         )

respiration20cm$table75 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption =  "Presence on the Last Quartile for Every Practice" )%>% kable_styling(
                                                                              c( "hover", "striped" ),
                                                                              full_width = FALSE,
                                                                              fixed_thead = TRUE
                                                                            )

respiration20cm$table15 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption =  "Presence on the Worst 15% for Every Practice" )%>% kable_styling(
                                                                          c( "hover", "striped" ),
                                                                          full_width = FALSE,
                                                                          fixed_thead = TRUE
                                                                        )
```

## Quality Replationships for Carbon Mass Percentage at 10cm

### Median Shifts

```{r organic10, echo=FALSE}
organic10$mediansPractices %>%
  mutate( factor = str_replace( factor, pattern = "farm_practices.", replacement ="" ) ) %>%
  kable( caption = "Farm Practices: Position Measures and Median Comparisons with the 'none' category" )%>% kable_styling(
                                                                                                              c( "hover", "striped" ),
                                                                                                              full_width = FALSE,
                                                                                                              fixed_thead = TRUE
                                                                                                            )

organic10$mediansAmendments %>%
  mutate( factor = str_replace( factor, pattern = "amendments.", replacement ="" ) ) %>%
  kable( caption = "Amendments: Position Measures and Median Comparisons with the 'none' category." )%>% kable_styling(
                                                                                                           c( "hover", "striped" ),
                                                                                                           full_width = FALSE,
                                                                                                           fixed_thead = TRUE
                                                                                                         )
```

### Density Variation on Certain Percentiles

On this tables, we attempt to find interesting patterns to explain atypicals and hopefully all variance for a given variable. 

We've already looked at these tables in detail on the *Quality Relationships* brief for produce: we are comparing how frequent is to find a certain quality for the full dataset and for a certain quantile, implying that if a certain attribute is more usual between the points on an extreme, it is worth checking if it is influential over the variable and explains the outlyingness of some values.

```{r organic10Freqs, echo=FALSE}
organic10$table90 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption = "Presence on the Last Decile for Every Practice" )%>% kable_styling(
                                                                           c( "hover", "striped" ),
                                                                           full_width = FALSE,
                                                                           fixed_thead = TRUE
                                                                         )

organic10$table75 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption =  "Presence on the Last Quartile for Every Practice" )%>% kable_styling(
                                                                              c( "hover", "striped" ),
                                                                              full_width = FALSE,
                                                                              fixed_thead = TRUE
                                                                            )

organic10$table15 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption =  "Presence on the Worst 15% for Every Practice" )%>% kable_styling(
                                                                          c( "hover", "striped" ),
                                                                          full_width = FALSE,
                                                                          fixed_thead = TRUE
                                                                        )
```

## Quality Replationships for Soil Carbon Mass Percentage at 20cm

### Median Shifts

```{r organic20, echo=FALSE}
organic20$mediansPractices %>%
  mutate( factor = str_replace( factor, pattern = "farm_practices.", replacement ="" ) ) %>%
  kable( caption = "Farm Practices: Position Measures and Median Comparisons with the 'none' category" )%>% kable_styling(
                                                                                                              c( "hover", "striped" ),
                                                                                                              full_width = FALSE,
                                                                                                              fixed_thead = TRUE
                                                                                                            )

organic20$mediansAmendments %>%
  mutate( factor = str_replace( factor, pattern = "amendments.", replacement ="" ) ) %>%
  kable( caption = "Amendments: Position Measures and Median Comparisons with the 'none' category." )%>% kable_styling(
                                                                                                           c( "hover", "striped" ),
                                                                                                           full_width = FALSE,
                                                                                                           fixed_thead = TRUE
                                                                                                         )
```

### Density Variation on Certain Percentiles

On this tables, we attempt to find interesting patterns to explain atypicals and hopefully all variance for a given variable.

We've already looked at these tables in detail on the *Quality Relationships* brief for produce: we are comparing how frequent is to find a certain quality for the full dataset and for a certain quantile, implying that if a certain attribute is more usual between the points on an extreme, it is worth checking if it is influential over the variable and explains the outlyingness of some values.

```{r organic20Freqs, echo=FALSE}
organic20$table90 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption = "Presence on the Last Decile for Every Practice" )%>% kable_styling(
                                                                           c( "hover", "striped" ),
                                                                           full_width = FALSE,
                                                                           fixed_thead = TRUE
                                                                         )

organic20$table75 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption =  "Presence on the Last Quartile for Every Practice" )%>% kable_styling(
                                                                              c( "hover", "striped" ),
                                                                              full_width = FALSE,
                                                                              fixed_thead = TRUE
                                                                            )

organic20$table15 %>%
  mutate( factor = str_replace( factor, "farm_practices.", replacement="" ) ) %>%
  kable( caption =  "Presence on the Worst 15% for Every Practice" )%>% kable_styling(
                                                                          c( "hover", "striped" ),
                                                                          full_width = FALSE,
                                                                          fixed_thead = TRUE
                                                                        )
```
